package no.tornado.databinding.converter;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class DateToStringConverter implements Converter<Date, String> {
    public static final DateToStringConverter DATE_INSTANCE = new DateToStringConverter(DateFormat.getDateInstance());
    public static final DateToStringConverter DATETIME_INSTANCE = new DateToStringConverter(DateFormat.getDateTimeInstance());
    private DateFormat dateFormat;

    public DateToStringConverter(String format) {
        dateFormat = new SimpleDateFormat(format);
    }

    public DateToStringConverter(DateFormat dateFormat) {
        this.dateFormat = dateFormat;
    }

    public String convertForward(Date value) throws ConversionException {
        if (value == null)
            return null;

        return dateFormat.format(value);
    }

    public Date convertReverse(String value) throws ConversionException {
        if (value == null || "".equals(value)) return null;
        try {
            return dateFormat.parse(value);
        } catch (ParseException ex) {
            throw new ConversionException(ex);
        }
    }
}
