package no.tornado.databinding.converter;

public class DoubleToStringConverter implements Converter<Double, String> {
    static DoubleToStringConverter INSTANCE = new DoubleToStringConverter();
    private DoubleToStringConverter() { }

    public String convertForward(Double value) throws ConversionException {
        return value != null ? value.toString() : null;
    }

    public Double convertReverse(String value) throws ConversionException {
        try {
            return value == null || "".equals(value) ? null : Double.valueOf(value);
        } catch (NumberFormatException e) {
            throw new ConversionException("Supply a valid decimal number", e);
        }
    }
}
