package no.tornado.databinding.converter;

public class FloatToStringConverter implements Converter<Float, String> {
    static FloatToStringConverter INSTANCE = new FloatToStringConverter();
    private FloatToStringConverter() { }
    
    public String convertForward(Float value) throws ConversionException {
        return value != null ? value.toString() : null;
    }

    public Float convertReverse(String value) throws ConversionException {
        try {
            return value == null || "".equals(value) ? null : Float.valueOf(value);
        } catch (NumberFormatException e) {
            throw new ConversionException("Supply a valid decimal number", e);
        }
    }
}
