package no.tornado.databinding.converter;

public class IntegerToStringConverter implements Converter<Integer, String> {
    static IntegerToStringConverter INSTANCE = new IntegerToStringConverter();
    private IntegerToStringConverter() { }
    
    public String convertForward(Integer value) throws ConversionException {
        return value != null ? value.toString() : null;
    }

    public Integer convertReverse(String value) throws ConversionException {
        try {
            return value == null || "".equals(value) ? null : Integer.valueOf(value);
        } catch (NumberFormatException e) {
            throw new ConversionException("Supply a valid number", e);
        }
    }

}
