package no.tornado.databinding.uibridge;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

public class DocumentChangeListener implements DocumentListener {
    private ChangeListener listener;

    public DocumentChangeListener(ChangeListener listener) {
        this.listener = listener;
    }

    public ChangeListener getListener() {
        return listener;
    }

    public void insertUpdate(DocumentEvent e) {
        listener.stateChanged(new ChangeEvent(e));
    }

    public void removeUpdate(DocumentEvent e) {
        listener.stateChanged(new ChangeEvent(e));
    }

    public void changedUpdate(DocumentEvent e) {
        listener.stateChanged(new ChangeEvent(e));
    }
}