package no.tornado.databinding.uibridge;

import no.tornado.databinding.converter.ConversionException;

import javax.swing.*;
import javax.swing.event.ChangeListener;

public class JCheckBoxBridge implements UIBridge<JCheckBox, ChangeListener, Boolean> {
    static JCheckBoxBridge INSTANCE = new JCheckBoxBridge();

    public Class<JCheckBox> getUIClass() {
        return JCheckBox.class;
    }

    public Class<? extends Boolean> getUIValueType() {
        return Boolean.class;
    }

    public void setUIValue(JCheckBox component, Boolean value) throws ConversionException {
        component.setSelected(value == null ? false : value);
    }

    public Boolean getUIValue(JCheckBox component) throws ConversionException {
        return component.isSelected();
    }

    public ChangeListener addValueChangeListener(JCheckBox component, ChangeListener listener) {
        component.addChangeListener(listener);
        return listener;
    }

    public void removeValueChangelistener(JCheckBox component, ChangeListener listener) {
        component.removeChangeListener(listener);
    }
}
