package no.tornado.databinding.uibridge;

import no.tornado.databinding.converter.ConversionException;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

public class JComboBoxBridge<UI_VALUE_TYPE> implements UIBridge<JComboBox, ItemListener, UI_VALUE_TYPE> {
    static JComboBoxBridge INSTANCE = new JComboBoxBridge();
    private JComboBoxBridge() { }

    public Class<JComboBox> getUIClass() {
        return JComboBox.class;
    }

    public Class<? extends UI_VALUE_TYPE> getUIValueType() {
        return (Class<? extends UI_VALUE_TYPE>) Object.class;
    }

    public void setUIValue(JComboBox component, UI_VALUE_TYPE value) throws ConversionException {
        component.getModel().setSelectedItem(value);
    }

    public UI_VALUE_TYPE getUIValue(JComboBox component) throws ConversionException {
        return (UI_VALUE_TYPE) component.getModel().getSelectedItem();
    }

    public ItemListener addValueChangeListener(JComboBox component, final ChangeListener listener) {
        ItemListener itemListener = new ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                listener.stateChanged(new ChangeEvent(e));
            }
        };
        component.addItemListener(itemListener);
        return itemListener;
    }

    public void removeValueChangelistener(JComboBox component, ItemListener listener) {
        component.removeItemListener(listener);
    }
        
}
