package no.tornado.databinding.uibridge;

import no.tornado.databinding.converter.ConversionException;

import javax.swing.*;
import javax.swing.event.ChangeListener;

public class JRadioButtonBridge implements UIBridge<JRadioButton, ChangeListener, Boolean> {
    static JRadioButtonBridge INSTANCE = new JRadioButtonBridge();

    private JRadioButtonBridge() { }

    public Class<JRadioButton> getUIClass() {
        return JRadioButton.class;
    }

    public Class<? extends Boolean> getUIValueType() {
        return Boolean.class;
    }

    public void setUIValue(JRadioButton component, Boolean value) throws ConversionException {
        component.setSelected(value == null ? false : value);
    }

    public Boolean getUIValue(JRadioButton component) throws ConversionException {
        return component.isSelected();
    }

    public ChangeListener addValueChangeListener(JRadioButton component, ChangeListener listener) {
        component.addChangeListener(listener);
        return listener;
    }

    public void removeValueChangelistener(JRadioButton component, ChangeListener listener) {
        component.removeChangeListener(listener);
    }
}
