package no.tornado.databinding.uibridge;

import no.tornado.databinding.converter.ConversionException;

import javax.swing.*;
import javax.swing.event.ChangeListener;

public class JSliderBridge implements UIBridge<JSlider, ChangeListener, Integer> {
    static JSliderBridge INSTANCE = new JSliderBridge();
    private JSliderBridge() { }

    public Class<JSlider> getUIClass() {
        return JSlider.class;
    }

    public Class<? extends Integer> getUIValueType() {
        return Integer.class;
    }

    public void setUIValue(JSlider component, Integer value) throws ConversionException {
        component.setValue(value);
    }

    public Integer getUIValue(JSlider component) throws ConversionException {
        return component.getValue();
    }

    public ChangeListener addValueChangeListener(JSlider component, ChangeListener listener) {
        component.addChangeListener(listener);
        return listener;
    }

    public void removeValueChangelistener(JSlider component, ChangeListener listener) {
        component.removeChangeListener(listener);
    }
}
