package no.tornado.databinding.uibridge;

import no.tornado.databinding.converter.ConversionException;

import javax.swing.*;
import javax.swing.event.ChangeListener;

public class JSpinnerBridge<UI_VALUE_TYPE> implements UIBridge<JSpinner, ChangeListener, UI_VALUE_TYPE> {
    static JSpinnerBridge INSTANCE = new JSpinnerBridge();
    private JSpinnerBridge() { }

    public Class<JSpinner> getUIClass() {
        return JSpinner.class;
    }

    public Class<? extends UI_VALUE_TYPE> getUIValueType() {
        return (Class<? extends UI_VALUE_TYPE>) Object.class;
    }

    public void setUIValue(JSpinner component, UI_VALUE_TYPE value) throws ConversionException {
        component.getModel().setValue(value);
    }

    public UI_VALUE_TYPE getUIValue(JSpinner component) throws ConversionException {
        return (UI_VALUE_TYPE) component.getModel().getValue();
    }

    public ChangeListener addValueChangeListener(JSpinner component, ChangeListener listener) {
        component.addChangeListener(listener);
        return listener;
    }

    public void removeValueChangelistener(JSpinner component, ChangeListener listener) {
        component.removeChangeListener(listener);
    }

}
