package no.tornado.databinding.uibridge;

import no.tornado.databinding.converter.ConversionException;

import javax.swing.*;
import javax.swing.event.ChangeListener;
import javax.swing.event.DocumentListener;

public class JTextAreaBridge implements UIBridge<JTextArea, DocumentListener, String> {
    static JTextAreaBridge INSTANCE = new JTextAreaBridge();
    private JTextAreaBridge() { }

    public Class<JTextArea> getUIClass() {
        return JTextArea.class;
    }

    public void setUIValue(JTextArea component, String value) throws ConversionException {
        component.setText(value);
    }

    public String getUIValue(JTextArea component) throws ConversionException {
        return component.getText();
    }

    public Class<? extends String> getUIValueType() {
        return String.class;
    }

    public DocumentListener addValueChangeListener(JTextArea component, ChangeListener listener) {
        DocumentListener documentListener = new DocumentChangeListener(listener);
        component.getDocument().addDocumentListener(documentListener);
        return documentListener;
    }

    public void removeValueChangelistener(JTextArea component, DocumentListener listener) {
        component.getDocument().removeDocumentListener(listener);
    }
}
