package no.tornado.databinding.uibridge;

import no.tornado.databinding.converter.ConversionException;

import javax.swing.*;
import javax.swing.event.ChangeListener;
import javax.swing.event.DocumentListener;

public class JTextFieldBridge implements UIBridge<JTextField, DocumentListener, String> {
    static JTextFieldBridge INSTANCE = new JTextFieldBridge();
    private JTextFieldBridge() { }
    
    public Class<JTextField> getUIClass() {
        return JTextField.class;
    }

    public Class<? extends String> getUIValueType() {
        return String.class;
    }

    public void setUIValue(JTextField component, String value) throws ConversionException {
        component.setText(value);
    }

    public String getUIValue(JTextField component) throws ConversionException {
        return component.getText();
    }

    public DocumentListener addValueChangeListener(JTextField component, ChangeListener listener) {
        DocumentListener documentListener = new DocumentChangeListener(listener);
        component.getDocument().addDocumentListener(documentListener);
        return documentListener;
    }

    public void removeValueChangelistener(JTextField component, DocumentListener listener) {
        component.getDocument().removeDocumentListener(listener);
    }

}
