package no.tornado.databinding.uibridge;

import no.tornado.databinding.converter.ConversionException;

import javax.swing.*;
import javax.swing.event.ChangeListener;

public class JToggleButtonBridge implements UIBridge<JToggleButton, ChangeListener, Boolean> {
    static JToggleButtonBridge INSTANCE = new JToggleButtonBridge();
    private JToggleButtonBridge() { }

    public Class<JToggleButton> getUIClass() {
        return JToggleButton.class;
    }

    public void setUIValue(JToggleButton component, Boolean value) throws ConversionException {
        component.setSelected(value);
    }

    public Boolean getUIValue(JToggleButton component) throws ConversionException {
        return component.isSelected();
    }

    public Class<? extends Boolean> getUIValueType() {
        return Boolean.class;
    }

    public ChangeListener addValueChangeListener(JToggleButton component, ChangeListener listener) {
        component.addChangeListener(listener);
        return listener;
    }

    public void removeValueChangelistener(JToggleButton component, ChangeListener listener) {
        component.removeChangeListener(listener);
    }
}
