package no.tornado.databinding.uibridge;

import no.tornado.databinding.converter.ConversionException;
import javax.swing.event.ChangeListener;

public interface UIBridge<UI_TYPE, UI_LISTENER_TYPE, UI_VALUE_TYPE> {
    public Class<UI_TYPE> getUIClass();
    public void setUIValue(UI_TYPE component, UI_VALUE_TYPE value) throws ConversionException;
    public UI_VALUE_TYPE getUIValue(UI_TYPE component) throws ConversionException;
    public Class<? extends UI_VALUE_TYPE> getUIValueType();
    public UI_LISTENER_TYPE addValueChangeListener(UI_TYPE component, ChangeListener listener);
    public void removeValueChangelistener(UI_TYPE component, UI_LISTENER_TYPE listener);
}
