package no.tornado.databinding.uibridge;

import java.util.Hashtable;
import java.util.ServiceLoader;

public class UIBridgeRegistry {
    private static Hashtable<Class, UIBridge> bridges = new Hashtable<Class, UIBridge>();

    static {
        for (UIBridgeProvider uiBridgeProvider : ServiceLoader.load(UIBridgeProvider.class))
            for (UIBridgeDescription desc : uiBridgeProvider.getBridgeDescriptions())
                bridges.put(desc.uiClass, desc.bridge);
    }

    public static UIBridge getBridge(Class uiClass) {
        return bridges.get(uiClass);
    }

    public static void addBridge(UIBridge bridge) {
        bridges.put(bridge.getUIClass(), bridge);
    }

    public static void removeBridge(UIBridge bridge) {
        if (bridge.equals(bridges.get(bridge.getClass())))
            bridges.remove(bridge.getUIClass());
    }
}
